package com.jojubanking.boot.module.system.service.mzjf;

import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;

import java.text.ParseException;
import java.util.*;
import com.jojubanking.boot.module.system.controller.admin.mzjf.vo.*;
import com.jojubanking.boot.module.system.dal.dataobject.mzjf.MzjfDO;
import com.jojubanking.boot.framework.common.pojo.PageResult;

import com.jojubanking.boot.module.system.convert.mzjf.MzjfConvert;
import com.jojubanking.boot.module.system.dal.mysql.mzjf.MzjfMapper;

import static com.jojubanking.boot.framework.common.exception.util.ServiceExceptionUtil.exception;
import static com.jojubanking.boot.module.system.enums.ErrorCodeConstants.*;

/**
 * 门诊缴费 Service 实现类
 *
 * @author admin
 */
@Service
@Validated
public class MzjfServiceImpl implements MzjfService {

    @Resource
    private MzjfMapper mzjfMapper;

    @Override
    public Integer createMzjf(MzjfCreateReqVO createReqVO) {
        // 插入
        MzjfDO mzjf = MzjfConvert.INSTANCE.convert(createReqVO);
        mzjfMapper.insert(mzjf);
        // 返回
        return mzjf.getId();
    }

    @Override
    public void updateMzjf(MzjfUpdateReqVO updateReqVO) {
        // 校验存在
        this.validateMzjfExists(updateReqVO.getId());
        // 更新
        MzjfDO updateObj = MzjfConvert.INSTANCE.convert(updateReqVO);
        mzjfMapper.updateById(updateObj);
    }

    @Override
    public void deleteMzjf(Integer id) {
        // 校验存在
        this.validateMzjfExists(id);
        // 删除
        mzjfMapper.deleteById(id);
    }

    private void validateMzjfExists(Integer id) {
        if (mzjfMapper.selectById(id) == null) {
            throw exception(MZJF_NOT_EXISTS);
        }
    }

    @Override
    public MzjfDO getMzjf(Integer id) {
        return mzjfMapper.selectById(id);
    }

    @Override
    public List<MzjfDO> getMzjfList(Collection<Integer> ids) {
        return mzjfMapper.selectBatchIds(ids);
    }

    @Override
    public PageResult<MzjfDO> getMzjfPage(MzjfPageReqVO pageReqVO) throws ParseException {
        return mzjfMapper.selectPage(pageReqVO);
    }

    @Override
    public List<MzjfDO> getMzjfList(MzjfExportReqVO exportReqVO) {
        return mzjfMapper.selectList(exportReqVO);
    }

}
